﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;




namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_OpenDevice(UInt32 DeviceType, UInt32 DeviceInd, UInt32 Reserved);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_CloseDevice(UInt32 DeviceType, UInt32 DeviceInd);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_InitCAN(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, ref VCI_INIT_CONFIG pInitConfig);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_ReadBoardInfo(UInt32 DeviceType, UInt32 DeviceInd, ref VCI_BOARD_INFO pInfo);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_ReadErrInfo(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, ref VCI_ERR_INFO pErrInfo);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_ReadCANStatus(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, ref VCI_CAN_STATUS pCANStatus);

        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_GetReference(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, UInt32 RefType, ref byte pData);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_SetReference(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, UInt32 RefType, ref byte pData);

        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_GetReceiveNum(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_ClearBuffer(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd);

        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_StartCAN(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd);
        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_ResetCAN(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd);

        [DllImport("controlcan.dll")]
        static extern UInt32 VCI_Transmit(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, ref VCI_CAN_OBJ pSend, UInt32 Len);
        //[DllImport("controlcan.dll")]
        //static extern UInt32 VCI_Receive(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, ref VCI_CAN_OBJ pReceive, UInt32 Len, Int32 WaitTime);
        [DllImport("controlcan.dll")]
        unsafe static extern UInt32 VCI_Receive(UInt32 DeviceType, UInt32 DeviceInd, UInt32 CANInd, VCI_CAN_OBJ* pReceive, UInt32 Len, Int32 WaitTime);

        //static UInt32 m_devtype = 4;//USBCAN2
        //static UInt32 m_devtype = (UInt32)can.DEV_TYPE.VCI_USBCAN1;//CANNETE
        static UInt32 m_devtype = (UInt32)can.DEV_TYPE.VCI_CANETE;//CANNETE

        UInt32 m_bOpen = 0;
        UInt32 m_devind = 0;
        UInt32 m_canind = 0;

        VCI_CAN_OBJ[] m_recobj = new VCI_CAN_OBJ[50];
        void InitRecObj()
        {
            for (int i = 0; i < m_recobj.Length;i++ )
            {
                m_recobj[i].Init();
            }
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox_DevIndex.SelectedIndex = 0;
            //comboBox_CANIndex.SelectedIndex = 0;
            //textBox_AccCode.Text = "00000000";
            //textBox_AccMask.Text = "FFFFFFFF";
            //textBox_Time0.Text = "00";
            //textBox_Time1.Text = "14";
            //comboBox_Filter.SelectedIndex = 1;
            //comboBox_Mode.SelectedIndex = 0;
            comboBox_SendType.SelectedIndex = 2;
            comboBox_FrameFormat.SelectedIndex = 0;
            comboBox_FrameType.SelectedIndex = 0;
            textBox_ID.Text = "00000123";
            textBox_Data.Text = "00 01 02 03 04 05 06 07 ";

            InitRecObj();
            checkbuttonenable();

        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (m_bOpen==1)
            {
                VCI_CloseDevice(m_devtype, m_devind);
            }
        }
        /// <summary>
        /// 整型数转字节数组
        /// </summary>
        /// <param name="b"></param>
        /// <returns></returns>
        public static UInt64 BytesToInt(byte[] b)
        {
            UInt64 mask = 0xff;
            UInt64 temp = 0;
            UInt64 res = 0;
            for (int i = 0; i < b.Length; i++)
            {
                res <<= 8;
                temp = b[i] & mask;
                res |= temp;
            }
            return res;
        }

        /// <summary>
        /// 字节数组转整型数
        /// </summary>
        /// <param name="num"></param>
        /// <param name="bits">位数，对于整形数的所占位数</param>
        /// <returns></returns>
        public static byte[] IntToBytes(UInt64 num, int bits)
        {
            byte[] b = new byte[bits];
            for (int i = 0; i < bits; i++)
            {
                //b[i] = (byte)(num >> ((bits - 1) * 8 - i * 8));//高字节在索引低处
                b[i] = (byte)((num >> (i * 8)) & 0xff);

            }
            return b;
        }



        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (m_bOpen==1)
            {
                VCI_CloseDevice(m_devtype, m_devind);
                m_bOpen = 0;
            }
            else
            {
                uint srcport =0;
                if (radioButton_udp.Checked)
                {
                    m_devtype = (UInt32)can.DEV_TYPE.VCI_CANETE;//
                    srcport =  Convert.ToUInt32(textBox_srcport.Text);
                }else
                {
                    m_devtype = (UInt32)can.DEV_TYPE.VCI_CANETTCP;//
                    srcport=0;
                }

                m_devind=(UInt32)comboBox_DevIndex.SelectedIndex;
                m_canind = 0;// (UInt32)comboBox_CANIndex.SelectedIndex;

                if (VCI_OpenDevice(m_devtype, m_devind, srcport) == 0)
                {
                    MessageBox.Show("打开设备失败,请检查设备类型和设备索引号是否正确", "错误",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }

                //m_bOpen = 1;
                //VCI_INIT_CONFIG config = new VCI_INIT_CONFIG();
                //config.AccCode = System.Convert.ToUInt32("0x" + textBox_AccCode.Text, 16);
                //config.AccMask = System.Convert.ToUInt32("0x" + textBox_AccMask.Text, 16);
                //config.Timing0 = System.Convert.ToByte("0x" + textBox_Time0.Text, 16);
                //config.Timing1 = System.Convert.ToByte("0x" + textBox_Time1.Text, 16);
                //config.Filter = (Byte)comboBox_Filter.SelectedIndex;
                //config.Mode = (Byte)comboBox_Mode.SelectedIndex;
                //VCI_InitCAN(m_devtype, m_devind, m_canind, ref config);

                //////////////////////////////////////////////////////////////////////////

                if (radioButton_tcps.Checked)//服务器模式
                {
                    //string srcip = textBox_srcip.Text;
                    //char[] chars = srcip.ToCharArray();
                    //byte[] bs = new byte[50];
                    //for (int i = 0; i < chars.Length; i++)
                    //{
                    //    bs[i] = (byte)chars[i];
                    //}
                    uint srcpo = Convert.ToUInt32(textBox_srcport.Text);
                    byte[] srcports = IntToBytes(srcpo, 4);
                    uint cmdtype = (uint)can.CMD.CMD_SRCPORT;
                    if ((uint)can.STATUS.STATUS_OK != VCI_SetReference(m_devtype, m_devind, m_canind, cmdtype, ref srcports[0]))
                    {
                        MessageBox.Show("设置目标IP出错 failed");
                        return;
                    }
                    cmdtype = (uint)can.CMD.CMD_TCP_TYPE;
                    uint tcptype = (uint)can.TCPTYPE.TCP_SERVER;
                    byte[] types = IntToBytes(tcptype, 4);
                    if ((uint)can.STATUS.STATUS_OK != VCI_SetReference(m_devtype, m_devind, m_canind, cmdtype, ref types[0]))
                    {
                        MessageBox.Show("设置TCP工作方式出错 failed");
                        return;
                    }
                }else
                {
                    //
                    string pip = textBox_IP.Text;
                    char[] chars = pip.ToCharArray();
                    byte[] bs = new byte[50];
                    for (int i = 0; i < chars.Length; i++)
                    {
                        bs[i] = (byte)chars[i];
                    }
                    uint cmdtype = (uint)can.CMD.CMD_DESIP;
                    if ((uint)can.STATUS.STATUS_OK != VCI_SetReference(m_devtype, m_devind, m_canind, cmdtype, ref bs[0]))
                    {
                        MessageBox.Show("设置目标IP出错 failed");
                        return;
                    }
                    //
                    uint desport = Convert.ToUInt32(textBox_desport.Text);
                    byte[] desports = IntToBytes(desport, 4);
                    cmdtype = (uint)can.CMD.CMD_DESPORT;
                    if ((uint)can.STATUS.STATUS_OK != VCI_SetReference(m_devtype, m_devind, m_canind, cmdtype, ref desports[0]))
                    {
                        MessageBox.Show("设置目标端口出错 failed");
                        return;
                    }
                    //
                    if (radioButton_tcpc.Checked)//TCP客户端
                    {
                        cmdtype = (uint)can.CMD.CMD_TCP_TYPE;
                        uint tcptype = (uint)can.TCPTYPE.TCP_CLIENT;
                        byte[] types = IntToBytes(tcptype, 4);
                        if ((uint)can.STATUS.STATUS_OK != VCI_SetReference(m_devtype, m_devind, m_canind, cmdtype, ref types[0]))
                        {
                            MessageBox.Show("设置TCP工作方式出错 failed");
                            return;
                        }
                    }
                }

                m_bOpen = 1;
            }
            buttonConnect.Text = m_bOpen==1?"断开":"连接";
            timer_rec.Enabled = m_bOpen==1?true:false;
        }

        unsafe private void timer_rec_Tick(object sender, EventArgs e)
        {
            UInt32 res = new UInt32();
            res=VCI_GetReceiveNum(m_devtype,m_devind,m_canind);
            if(res==0)
                return;

            //res = VCI_Receive(m_devtype, m_devind, m_canind, ref m_recobj[0],/*50*/1, 100);
            fixed (VCI_CAN_OBJ* pobj = &m_recobj[0])
            {
                res = VCI_Receive(m_devtype, m_devind, m_canind, pobj, 50/*50*/, 100);
            }

            String str = "";
            for (UInt32 i = 0; i < res; i++)
            {
                str = "接收到数据: ";
                str += "  帧ID:0x" + System.Convert.ToString((Int32)m_recobj[i].ID, 16);
                str += "  帧格式:";
                if (m_recobj[i].RemoteFlag == 0)
                    str += "数据帧 ";
                else
                    str += "远程帧 ";
                if (m_recobj[i].ExternFlag == 0)
                    str += "标准帧 ";
                else
                    str += "扩展帧 ";
                if (m_recobj[i].RemoteFlag == 0)
                {
                    str+="数据: ";
                    byte len=(byte)(m_recobj[i].DataLen%9);
                    byte j = 0;

                    fixed (byte* bdata = m_recobj[i].Data)
                    {
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[0], 16);
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[1], 16);
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[2], 16);
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[3], 16);
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[4], 16);
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[5], 16);
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[6], 16);
                        if (j++ < len)
                            str += " " + System.Convert.ToString(bdata[7], 16);
                    }



                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[0], 16);
                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[1], 16);
                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[2], 16);
                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[3], 16);
                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[4], 16);
                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[5], 16);
                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[6], 16);
                    //if (j++ < len)
                    //    str += " " + System.Convert.ToString(m_recobj[i].Data[7], 16);
                }
                listBox_Info.Items.Add(str);
                listBox_Info.SelectedIndex = listBox_Info.Items.Count - 1;
            }
        }

        private void button_StartCAN_Click(object sender, EventArgs e)
        {
            if (m_bOpen == 0)
                return;
            if (1!=VCI_StartCAN(m_devtype, m_devind, m_canind))
            {
                MessageBox.Show("启动失败", "错误",MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
            listBox_Info.Items.Add("启动成功");
            listBox_Info.SelectedIndex = listBox_Info.Items.Count - 1;           
        }

        private void button_StopCAN_Click(object sender, EventArgs e)
        {
            if (m_bOpen == 0)
                return;
            VCI_ResetCAN(m_devtype, m_devind, m_canind);
        }

        unsafe private void button_Send_Click(object sender, EventArgs e)
        {
            if(m_bOpen==0)
                return;

            VCI_CAN_OBJ sendobj = new VCI_CAN_OBJ();
            sendobj.Init();
            sendobj.SendType = (byte)comboBox_SendType.SelectedIndex;
            sendobj.RemoteFlag = (byte)comboBox_FrameFormat.SelectedIndex;
            sendobj.ExternFlag = (byte)comboBox_FrameType.SelectedIndex;
            sendobj.ID = System.Convert.ToUInt32("0x"+textBox_ID.Text,16);
            int len = (textBox_Data.Text.Length+1) / 3;
            sendobj.DataLen =System.Convert.ToByte(len);
            String strdata = textBox_Data.Text;
            int i=-1;
            if(i++<len-1)
                sendobj.Data[0]=System.Convert.ToByte("0x" +strdata.Substring(i * 3, 2),16);
            if (i++ < len - 1)
                sendobj.Data[1]=System.Convert.ToByte("0x" +strdata.Substring(i * 3, 2),16);
            if (i++ < len - 1)
                sendobj.Data[2]=System.Convert.ToByte("0x" +strdata.Substring(i * 3, 2),16);
            if (i++ < len - 1)
                sendobj.Data[3]=System.Convert.ToByte("0x" +strdata.Substring(i * 3, 2),16);
            if (i++ < len - 1)
                sendobj.Data[4]=System.Convert.ToByte("0x" +strdata.Substring(i * 3, 2),16);
            if (i++ < len - 1)
                sendobj.Data[5]=System.Convert.ToByte("0x" +strdata.Substring(i * 3, 2),16);
            if (i++ < len - 1)
                sendobj.Data[6]=System.Convert.ToByte("0x" +strdata.Substring(i * 3, 2),16);
            if (i++ < len - 1)
                sendobj.Data[7] = System.Convert.ToByte("0x" + strdata.Substring(i * 3, 2), 16);

            if(VCI_Transmit(m_devtype,m_devind,m_canind,ref sendobj,1)==0)
            {
                MessageBox.Show("发送失败", "错误",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            listBox_Info.Items.Add("发送成功");
            listBox_Info.SelectedIndex = listBox_Info.Items.Count - 1;
        }
        void checkbuttonenable()
        {
            if (radioButton_tcps.Checked)
            {
                //textBox_srcip.Enabled = true;
                textBox_srcip.Enabled = false;
                textBox_IP.Enabled = false;
                textBox_desport.Enabled = false;
                textBox_srcport.Enabled = true;
            }else
            {
                textBox_srcip.Enabled = false;
                textBox_IP.Enabled = true;
                textBox_desport.Enabled = true;
                if (radioButton_tcpc.Checked)
                {
                    textBox_srcport.Enabled = false;
                }else
                {
                    textBox_srcport.Enabled = true;
                }
            }

        }
        private void radioButton_tcps_CheckedChanged(object sender, EventArgs e)
        {
            checkbuttonenable();
        }

        private void radioButton_udp_CheckedChanged(object sender, EventArgs e)
        {
            checkbuttonenable();
        }

        private void radioButton_tcpc_CheckedChanged(object sender, EventArgs e)
        {
            checkbuttonenable();
        }


    }
}

namespace can
{

    // 设备型号
    public enum DEV_TYPE
    {
        VCI_PCI5121 = 1,
        VCI_PCI9810 = 2,
        VCI_USBCAN1 = 3,
        VCI_USBCAN2 = 4,
        VCI_USBCAN2A = 4,
        VCI_PCI9820 = 5,
        VCI_CAN232 = 6,
        VCI_PCI5110 = 7,
        VCI_CANLITE = 8,
        VCI_ISA9620 = 9,
        VCI_ISA5420 = 10,
        VCI_PC104CAN = 11,
        VCI_CANETE = 12,
        VCI_DNP9810 = 13,
        VCI_PCI9840 = 14,
        VCI_PC104CAN2 = 15,
        VCI_PCI9820I = 16,
        VCI_PEC9920 = 18,
        VCI_CANETTCP = 17,
        VCI_PCI5010U = 19,
        VCI_USBCANEU = 20,
        VCI_USBCAN2EU = 21,
    };

    // CAN错误码
    public enum CAN_ERR
    {
        ERR_CAN_OVERFLOW = 0x0001, //CAN控制器内部FIFO溢出
        ERR_CAN_ERRALARM = 0x0002, //CAN控制器错误报警
        ERR_CAN_PASSIVE = 0x0004, //CAN控制器消极错误
        ERR_CAN_LOSE = 0x0008, //CAN控制器仲裁丢失
        ERR_CAN_BUSERR = 0x0010, //CAN控制器总线错误
        ERR_CAN_BUSCLOSE = 0x0020, //CAN控制器总线关闭
    };

    // 通用错误码
    public enum DEV_ERR
    {
        ERR_DEVICEOPENED = 0x0100, //设备已经打开
        ERR_DEVICEOPEN = 0x0200, //打开设备错误
        ERR_DEVICENOTOPEN = 0x0400, //设备没有打开
        ERR_BUFFEROVERFLOW = 0x0800, //缓冲区溢出
        ERR_DEVICENOTEXIST = 0x1000, //此设备不存在
        ERR_LOADKERNELDLL = 0x2000, //装载动态库失败
        ERR_CMDFAILED = 0x4000, //执行命令失败错误码
        ERR_BUFFERCREATE = 0x8000, //内存不足
    };

    // 函数调用返回状态值
    public enum STATUS
    {
        STATUS_OK = 1,
        STATUS_ERR = 0,
    };

    // 函数调用返回状态值
    public enum CMD
    {
        CMD_DESIP = 0,
        CMD_DESPORT = 1,
        CMD_SRCPORT=2,
        CMD_CHGDESIPANDPORT = 2,
        CMD_TCP_TYPE = 4,//tcp 工作方式，服务器:1 或是客户端:0
    };

    public enum TCPTYPE
    {
        TCP_CLIENT = 0,
        TCP_SERVER = 1,
    }

    public enum REF
    {
        REFERENCE_BAUD = 1,
        REFERENCE_SET_TRANSMIT_TIMEOUT = 2,
        REFERENCE_ADD_FILTER = 3,
        REFERENCE_SET_FILTER = 4,
    };
}

//1.ZLGCAN系列接口卡信息的数据类型。
public struct VCI_BOARD_INFO
{
    public UInt16 hw_Version;
    public UInt16 fw_Version;
    public UInt16 dr_Version;
    public UInt16 in_Version;
    public UInt16 irq_Num;
    public byte can_Num;
    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
    public byte[] str_Serial_Num;
    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 40)]
    public byte[] str_hw_Type;
    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
    public byte[] Reserved;
}

//2.定义CAN信息帧的数据类型。
//public struct VCI_CAN_OBJ
//{
//    public UInt32 ID;
//    public UInt32 TimeStamp;
//    public byte TimeFlag;
//    public byte SendType;
//    public byte RemoteFlag;//是否是远程帧
//    public byte ExternFlag;//是否是扩展帧
//    public byte DataLen;
//    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
//    public byte[] Data;
//    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 3)]
//    public byte[] Reserved;


//    public void Init()
//    {
//        Data = new byte[8];
//        Reserved = new byte[3];
//    }
//}
//2.定义CAN信息帧的数据类型。
unsafe public struct VCI_CAN_OBJ  //使用不安全代码
{
    public uint ID;
    public uint TimeStamp;
    public byte TimeFlag;
    public byte SendType;
    public byte RemoteFlag;//是否是远程帧
    public byte ExternFlag;//是否是扩展帧
    public byte DataLen;

    public fixed byte Data[8];

    public fixed byte Reserved[3];


    public void Init()
    {
        //Data = new byte[8];
        //Reserved = new byte[3];
    }
}

//3.定义CAN控制器状态的数据类型。
public struct VCI_CAN_STATUS
{
    public byte ErrInterrupt;
    public byte regMode;
    public byte regStatus;
    public byte regALCapture;
    public byte regECCapture;
    public byte regEWLimit;
    public byte regRECounter;
    public byte regTECounter;
    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
    public byte[] Reserved;
}

//4.定义错误信息的数据类型。
public struct VCI_ERR_INFO
{
    public UInt32 ErrCode;
    public byte Passive_ErrData1;
    public byte Passive_ErrData2;
    public byte Passive_ErrData3;
    public byte ArLost_ErrData;
}

//5.定义初始化CAN的数据类型
public struct VCI_INIT_CONFIG
{
    public UInt32 AccCode;
    public UInt32 AccMask;
    public UInt32 Reserved;
    public byte Filter;
    public byte Timing0;
    public byte Timing1;
    public byte Mode;
}

public struct CHGDESIPANDPORT
{
    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
    public byte[] szpwd;
    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
    public byte[] szdesip;
    public Int32 desport;

    public void Init()
    {
        szpwd = new byte[10];
        szdesip = new byte[20];
    }
}